"""
Django settings for sweetraccoon project.

Generated by 'django-admin startproject' using Django 5.0.4.

For more information on this file, see
https://docs.djangoproject.com/en/5.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/5.0/ref/settings/
"""

import logging
import os
from pathlib import Path

from dotenv import load_dotenv

from .logging import *
from .simple_history import *

logger = logging.getLogger(__name__)

load_dotenv()


### start config initial ###
ALLOW_API_READ_WITHOUT_AUTHENTICATION = True
PAGINATE_BY_CBV_RACKS = 25
PAGINATE_BY_CBV_DEVICES = 25
IN_STATE_TO_COUNT_IN_USED_UNITS = ["PLA", "PRO", "PRE", "MAI"]
IN_STATE_TO_EXCLUDE_IN_USED_UNITS = ["REM", "DEC"]
IN_STATE_DEVICES_TO_EXCLUDE_INSIDE_RACKS = ["REM", "DEC"]
IN_STATE_COLORS_TAGS = {
    "PLA": "bg-info",
    "PRO": "bg-info",
    "PRE": "bg-success",
    "MAI": "bg-warning",
    "REM": "bg-secondary",
    "DEC": "bg-secondary",
}
### end start config initial ###


# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/5.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
if os.getenv("SECRET_KEY") and os.getenv("SECRET_KEY") != "":
    SECRET_KEY = os.getenv("SECRET_KEY")
else:
    SECRET_KEY = None

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

if os.getenv("ALLOWED_HOSTS") and os.getenv("ALLOWED_HOSTS") != "":
    ALLOWED_HOSTS = os.getenv("ALLOWED_HOSTS").split(" ")
else:
    ALLOWED_HOSTS = []

if os.getenv("CORS_ORIGIN_WHITELIST") and os.getenv("CORS_ORIGIN_WHITELIST") != "":
    CORS_ORIGIN_WHITELIST = os.getenv("CORS_ORIGIN_WHITELIST").split(" ")
else:
    CORS_ORIGIN_WHITELIST = []

# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "rest_framework",
    "corsheaders",
    "simple_history",
    "crispy_forms",
    "crispy_bootstrap5",
    "datacenter",
]

#### start CRISPY FORMS ####
CRISPY_ALLOWED_TEMPLATE_PACKS = "bootstrap5"
CRISPY_TEMPLATE_PACK = "bootstrap5"
CRISPY_FAIL_SILENTLY = False
#### end CRISPY FORMS ####

REST_FRAMEWORK = {
    "DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination",
    "PAGE_SIZE": 15,
}

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "simple_history.middleware.HistoryRequestMiddleware",
]

CSRF_TRUSTED_ORIGINS = [f"https://{host}" for host in ALLOWED_HOSTS] + [
    "http://*.localhost"
]

ROOT_URLCONF = "core.urls"

if os.getenv("PROJECT_NAME") and os.getenv("PROJECT_NAME") != "":
    PROJECT_NAME = os.getenv("PROJECT_NAME")
else:
    PROJECT_NAME = "SweetRaccoon"

if os.getenv("ENVIRON_NAME") and os.getenv("ENVIRON_NAME") != "":
    ENVIRON_NAME = os.getenv("ENVIRON_NAME")
else:
    ENVIRON_NAME = "PROD"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [
            BASE_DIR / "./templates/",
        ],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
            "libraries": {
                "localtags": "core.templatetags.localtags",
            },
        },
    },
]

WSGI_APPLICATION = "core.wsgi.application"


# Database
# https://docs.djangoproject.com/en/5.0/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": BASE_DIR / "db.sqlite3",
    }
}


# Password validation
# https://docs.djangoproject.com/en/5.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

AUTH_USER_MODEL = "datacenter.User"

# Internationalization
# https://docs.djangoproject.com/en/5.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "Europe/Paris"

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/5.0/howto/static-files/

STATIC_URL = "static/"
STATICFILES_DIRS = [os.path.join(BASE_DIR, "static")]
STATIC_ROOT = BASE_DIR / "staticfiles"

# Default primary key field type
# https://docs.djangoproject.com/en/5.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"
